﻿#define DECLARE_EXTENSION_METHOD

using System;

namespace LinqToNothingWithExtensionMethods {

	class NothingInt5 {
		public int Where(Predicate<int> p) {
			Console.WriteLine("NothingInt5.Where called.");
			return 5;
		}

		public override string ToString() {
			return "5 is really nothing!";
		}
	}

	class Program {
		static void Main(string[] args) {
			// Following query will not compile because .Where(x => x > 5) on NothingInt5 returns an int 
			// and no Where method exists on int (to evaluate the following .Where(x => x < 10).
			// Error: Could not find an implementation of the query pattern for source type 'int'. 'Where' not found.
			//		var q2i5 = from x in new NothingInt5() where x > 5 where x < 10 select x;

			var q2i5 = from x in new NothingInt5() where x > 5 where x < 10 select x;
			Console.WriteLine("Result type: {0}", q2i5.GetType());
			Console.WriteLine("Result: {0}", q2i5);
		}
	}

#if DECLARE_EXTENSION_METHOD
	static class IntExtensions {
		public static int Where(this int i, Predicate<int> p) {
			Console.WriteLine("IntExtensions.Where called.");
			return i + 100;
		}
	}
#endif
}
